﻿local LibQTip = LibStub('LibQTip-1.0')
local dataobject = LibStub("LibDataBroker-1.1"):NewDataObject("tBrokerXP", {
	type = "data source",
	icon = "Interface\\CharacterFrame\\UI-StateIcon",
	label = "XP",
	texcoord = {0.09, 0.43, 0.08, 0.42},
	OnEnter = function(self)
		local tooltip = LibQTip:Acquire("bXP_tt", 6, "LEFT", "LEFT", "CENTER", "CENTER", "RIGHT", "RIGHT")
		self.tooltip = tooltip
		tooltip:AddHeader("Character", "lvl", "XP", "Rested", "Zone")
		for ProfileRealmName,charData in pairs(DataStore_CharactersDB["global"]["Characters"]) do
			local _,realm,name = strsplit(".",ProfileRealmName)
			if realm ~= GetRealmName() then
				break
			end
			local s = string.format("|cff%02x%02x%02x%s|r", RAID_CLASS_COLORS[charData["englishClass"]].r*255, RAID_CLASS_COLORS[charData["englishClass"]].g*255, RAID_CLASS_COLORS[charData["englishClass"]].b*255, name)
			if charData["faction"] == "Horde" then
				s = "|TInterface\\Icons\\INV_BannerPVP_01:0:::|t" .. s
			else
				s = "|TInterface\\Icons\\INV_BannerPVP_02:0:::|t" .. s
			end
			local xp, rested
			if charData["level"] < 80 then
				xp = string.format("%u/%u (%.2f%%)",charData["XP"],charData["XPMax"],100*charData["XP"]/charData["XPMax"])
				if name == UnitName("player") then
					rested = 0
				else
					rested = charData["XPMax"] * (time() - charData["lastLogoutTimestamp"]) / 2304000
				end
				if charData["isResting"] then
					rested = rested * 4
					xp = string.format("|cff00ff00%s|r", xp)
				else
					xp = string.format("|cffff0000%s|r", xp)
				end
				rested = 100 * (rested + charData["RestXP"]) / charData["XPMax"]
				if rested > 150 then
					rested = 150
				end
				if rested<75 then
					rested = string.format("|cffff%02x00%.2f%%|r", 255*rested/75, rested)
				else
					rested = string.format("|cff%02xff00%.2f%%|r", 255*(2-rested/75), rested)
				end
			else
				xp = ""
				rested = ""
			end
			local z = charData["zone"]
			if not z then
				z = ""
			end
			if charData["subZone"] and charData["subZone"] ~= "" then
				z = z .. " - " .. charData["subZone"]
			end
			tooltip:AddLine(s,tostring(charData["level"]),xp,rested,z)
		end
		tooltip:SmartAnchorTo(self)
		tooltip:Show()
	end,
	OnLeave = function(self)
		LibQTip:Release(self.tooltip)
		self.tooltip = nil
	end,
})

local frame = CreateFrame("Frame")
frame:SetScript("OnUpdate", function()
    if IsResting() then
        dataobject.texcoord = {0, 0.5, 0, 0.5}
    else
        dataobject.texcoord = {0, 0.5, 0.5, 1}
    end
end)
